package com.tashow.cloud.user.dal.mysql.user;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.tashow.cloud.common.pojo.PageResult;
import com.tashow.cloud.mybatis.mybatis.core.mapper.BaseMapperX;
import com.tashow.cloud.mybatis.mybatis.core.query.LambdaQueryWrapperX;
import com.tashow.cloud.user.controller.admin.user.vo.UserLoginPageReqVO;
import com.tashow.cloud.user.dal.dataobject.user.UserLoginDO;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 会员 User Mapper
 *
 * @author 芋道源码
 */
@Mapper
public interface UserLoginMapper extends BaseMapperX<UserLoginDO> {

    default UserLoginDO selectByMobile(String mobile) {
        return selectOne(UserLoginDO::getMobile, mobile);
    }

    default List<UserLoginDO> selectListByNicknameLike(String nickname) {
        return selectList(new LambdaQueryWrapperX<UserLoginDO>()
                .likeIfPresent(UserLoginDO::getNickname, nickname));
    }

    default PageResult<UserLoginDO> selectPage(UserLoginPageReqVO reqVO) {
        // 分页查询
        return selectPage(reqVO, new LambdaQueryWrapperX<UserLoginDO>()
                .orderByDesc(UserLoginDO::getId));
    }

    default Long selectCountByTagId(Long tagId) {
        return selectCount(new LambdaQueryWrapperX<UserLoginDO>()
                .apply("FIND_IN_SET({0}, tag_ids)", tagId));
    }

    /**
     * 更新用户积分（增加）
     *
     * @param id        用户编号
     * @param incrCount 增加积分（正数）
     */
    default void updatePointIncr(Long id, Integer incrCount) {
        Assert.isTrue(incrCount > 0);
        LambdaUpdateWrapper<UserLoginDO> lambdaUpdateWrapper = new LambdaUpdateWrapper<UserLoginDO>()
                .setSql(" point = point + " + incrCount)
                .eq(UserLoginDO::getId, id);
        update(null, lambdaUpdateWrapper);
    }

    /**
     * 更新用户积分（减少）
     *
     * @param id        用户编号
     * @param incrCount 增加积分（负数）
     * @return 更新行数
     */
    default int updatePointDecr(Long id, Integer incrCount) {
        Assert.isTrue(incrCount < 0);
        LambdaUpdateWrapper<UserLoginDO> lambdaUpdateWrapper = new LambdaUpdateWrapper<UserLoginDO>()
                .setSql(" point = point + " + incrCount) // 负数，所以使用 + 号
                .eq(UserLoginDO::getId, id);
        return update(null, lambdaUpdateWrapper);
    }

}
